#include <NTPClient.h>
#include <ESP8266WiFi.h>
#include <WiFiUdp.h>
#include <ESP8266HTTPUpdateServer.h>
#include <ArduinoJson.h>
#include <ESP8266HTTPClient.h>

const char *ssid     = "SSID";
const char *password = "pass";
const long utcOffsetInSeconds = 7200;//change for your needs
String formattedDate;
String req="insert your post link for temp"
int dataPin=D7;
int latchPin=D6;
int clockPin=D5;
int toggle=D4;
int minuti;//mins
int chas; //hrs
int mes_int,den_int;//month and day
int temperature,humidity;

WiFiUDP ntpUDP;
NTPClient timeClient(ntpUDP, "europe.pool.ntp.org", utcOffsetInSeconds);
HTTPClient http;  //Object of class HTTPClient
const size_t capacity = JSON_OBJECT_SIZE(15) + 370;
DynamicJsonDocument doc(capacity);

void setup(){
  Serial.begin(9600);
  WiFi.begin(ssid,password);
  while ( WiFi.status() != WL_CONNECTED ) 
  {
    delay ( 500 );
    Serial.print ( "." );
  }
  pinMode(dataPin,OUTPUT);
  pinMode(clockPin,OUTPUT);
  pinMode(latchPin,OUTPUT);
  pinMode(toggle,INPUT_PULLUP);
  timeClient.begin();
}

void loop() {
  timeClient.update(); 
  if(minuti!=timeClient.getMinutes() || chas!=timeClient.getHours())
  {
    minuti=timeClient.getMinutes();
    chas=timeClient.getHours();
    date();
    test_animation();
    shift_display(den_int,mes_int);
    delay(3000);
    temp();
    test_animation();
    shift_display(temperature,humidity);
    delay(3000);
    test_animation();
    shift_display(chas,minuti);
    delay(100);
  }
}
void shift_display(int chis1,int chis2)
{
 int min_des,min_ed,chas_des,chas_ed;
 byte min_des1,min_ed1,chas_des1,chas_ed1;
 min_ed=chis2%10;
 min_des=chis2/10;
 chas_ed=chis1%10;
 chas_des=chis1/10;
 min_ed1=(byte)min_ed;
 min_des1=(byte)min_des;
 chas_ed1=(byte)chas_ed;
 chas_des1=(byte)chas_des;
 digitalWrite(latchPin,LOW);
 digitalWrite(clockPin, LOW);
 shiftOut(dataPin,clockPin,MSBFIRST,(chas_des1<<4)+chas_ed1);
 digitalWrite(clockPin, LOW);
 shiftOut(dataPin,clockPin,MSBFIRST,(min_des1<<4)+min_ed1);
 digitalWrite(latchPin,HIGH);
}
void test_animation()
{
  for(int i=0;i<10;i++)
  {
    byte j=(byte)i;
    digitalWrite(latchPin,LOW);
    digitalWrite(clockPin, LOW);
    shiftOut(dataPin,clockPin,MSBFIRST,(j<<4)+j);
    digitalWrite(clockPin, LOW);
    shiftOut(dataPin,clockPin,MSBFIRST,(j<<4)+j);
    digitalWrite(latchPin,HIGH);
    delay(25);
  }
}
void date()
{
  char a[22];
  while(!timeClient.update()) 
    {
    timeClient.forceUpdate();
    } 
     formattedDate = timeClient.getFormattedDate();
     formattedDate.toCharArray(a,20);
     a[4]=' ';
     a[7]=' ';
     a[10]=' ';
     a[13]=' ';
     a[16]=' ';
     a[19]=' ';
     String mesec,den;
     mesec.concat(String(a[5]));
     mesec.concat(String(a[6]));
     den.concat(String(a[8]));
     den.concat(String(a[9]));
     mes_int=mesec.toInt();
     den_int=den.toInt();
}
void temp()
{
    http.begin(req);
    http.addHeader("Content-Type", "text/plain");
    deserializeJson(doc, http.getString());
    temperature = doc["temperatures"]; 
    humidity = doc["humidity"];
    http.end();
    }
}
